Skip to example

AnimateView: Transition types

An example of using AnimateView with addTransitionType to create directional prev/next slideshow animations using Motion for React.

React

Source code

"use client"

import { spring, wrap } from "motion"
import { AnimateView } from "motion/react-animate-view"
import { addTransitionType, startTransition, SVGProps, useState } from "react"

/**
 * Title: AnimateView: Transition types
 */

const images = Array.from(
    { length: 6 },
    (_, i) => `/photos/prague/image-${String(i + 1).padStart(2, "0")}.jpg`
)

function Slide({ index }: { index: number }) {
    return (
        <AnimateView
            key={index}
            name={`slide-${index}`}
            transition={{
                type: spring,
                visualDuration: 0.3,
                bounce: 0.2,
            }}
            exit={(types) => ({
                opacity: 0,
                transform: `translateX(${
                    types.includes("prev") ? 100 : -100
                }%)`,
            })}
            enter={(types) => ({
                opacity: 1,
                transform: [
                    `translateX(${types.includes("next") ? 100 : -100}%)`,
                    "translateX(0%)",
                ],
            })}
        >
            <div style={slideContainer}>
                <img
                    src={images[index]}
                    alt={`Prague ${index + 1}`}
                    style={imageStyle}
                />
            </div>
        </AnimateView>
    )
}

export default function TransitionTypes() {
    const [index, setIndex] = useState(0)

    const navigate = (direction: "next" | "prev") => {
        startTransition(() => {
            addTransitionType(direction)
            setIndex(
                wrap(0, images.length, index + (direction === "next" ? 1 : -1))
            )
        })
    }

    return (
        <div className="view-transition-types" style={container}>
            <button
                style={button}
                aria-label="Previous"
                onClick={() => navigate("prev")}
            >
                <ArrowLeft />
            </button>
            <Slide key={index} index={index} />
            <button
                style={button}
                aria-label="Next"
                onClick={() => navigate("next")}
            >
                <ArrowRight />
            </button>
            <span style={counter}>
                {index + 1} / {images.length}
            </span>
            <StyleSheet />
        </div>
    )
}

/**
 * ==============   Icons   ================
 */

const iconProps: SVGProps<SVGSVGElement> = {
    xmlns: "http://www.w3.org/2000/svg",
    width: "24",
    height: "24",
    viewBox: "0 0 24 24",
    fill: "none",
    stroke: "currentColor",
    strokeWidth: "2",
    strokeLinecap: "round",
    strokeLinejoin: "round",
}

function ArrowLeft() {
    return (
        <svg {...iconProps}>
            <path d="m12 19-7-7 7-7" />
            <path d="M19 12H5" />
        </svg>
    )
}

function ArrowRight() {
    return (
        <svg {...iconProps}>
            <path d="M5 12h14" />
            <path d="m12 5 7 7-7 7" />
        </svg>
    )
}

/**
 * ==============   Styles   ================
 */

const container: React.CSSProperties = {
    display: "flex",
    position: "relative",
    justifyContent: "center",
    alignItems: "center",
    flexWrap: "wrap",
    gap: 10,
    width: "100%",
    height: "100%",
}

const counter: React.CSSProperties = {
    width: "100%",
    textAlign: "center",
    fontSize: 14,
    color: "var(--feint-text)",
}

const slideContainer: React.CSSProperties = {
    width: 400,
    height: 300,
    borderRadius: 10,
    overflow: "hidden",
}

const imageStyle: React.CSSProperties = {
    display: "block",
    width: "100%",
    height: "100%",
    objectFit: "cover",
}

const button: React.CSSProperties = {
    width: 40,
    height: 40,
    borderRadius: "50%",
    display: "flex",
    justifyContent: "center",
    alignItems: "center",
    position: "relative",
    zIndex: 1,
    outlineOffset: 2,
    border: "none",
    cursor: "pointer",
    color: "white",
    backgroundColor: "rgba(255, 255, 255, 0.15)",
}

/**
 * ==============   Stylesheet   ================
 */

function StyleSheet() {
    return (
        <style>{`
            .view-transition-types > button:hover {
                background-color: rgba(255, 255, 255, 0.25) !important;
            }
        `}</style>
    )
}

Skip to example

AnimateView: Transition types

A direction-aware image carousel that reads transition types to slide images in from the correct side.

Vue

Source code

<script setup lang="ts">
import { AnimateView, spring, startTransition, wrap } from 'motion-v'
import { ChevronLeft, ChevronRight } from 'lucide-vue-next'
import { ref } from 'vue'

const images = Array.from(
  { length: 6 },
  (_, i) => `/photos/prague/image-${String(i + 1).padStart(2, '0')}.jpg`,
)

// Preload so slides don't pop in mid-transition
images.forEach((src) => {
  const img = new Image()
  img.src = src
})

const index = ref(0)

const slideSpring = {
  type: spring,
  visualDuration: 0.3,
  bounce: 0.2,
}

function navigate(direction: 'next' | 'prev') {
  startTransition(
    () => {
      index.value = wrap(
        0,
        images.length,
        index.value + (direction === 'next' ? 1 : -1),
      )
    },
    { types: [direction] },
  )
}

function enterSlide(types: string[]) {
  return {
    opacity: 1,
    transform: [
      `translateX(${types.includes('next') ? 100 : -100}%)`,
      'translateX(0%)',
    ],
  }
}

function exitSlide(types: string[]) {
  return {
    opacity: 0,
    transform: `translateX(${types.includes('prev') ? 100 : -100}%)`,
  }
}
</script>

<template>
  <div class="types-example">
    <button
      class="nav-button"
      aria-label="Previous"
      @click="navigate('prev')"
    >
      <ChevronLeft :size="24" />
    </button>
    <AnimateView
      :key="index"
      :name="`slide-${index}`"
      :transition="slideSpring"
      :exit="exitSlide"
      :enter="enterSlide"
    >
      <div class="slide">
        <img
          :src="images[index]"
          :alt="`Prague ${index + 1}`"
          class="slide-image"
        >
      </div>
    </AnimateView>
    <button
      class="nav-button"
      aria-label="Next"
      @click="navigate('next')"
    >
      <ChevronRight :size="24" />
    </button>
    <span class="counter">{{ index + 1 }} / {{ images.length }}</span>
  </div>
</template>

<style scoped>
.types-example {
  display: flex;
  position: relative;
  justify-content: center;
  align-items: center;
  flex-wrap: wrap;
  gap: 10px;
  width: 100%;
  height: 100%;
}

.counter {
  width: 100%;
  text-align: center;
  font-size: 14px;
  color: var(--feint-text);
}

.slide {
  width: 400px;
  height: 300px;
  border-radius: 10px;
  overflow: hidden;
}

.slide-image {
  display: block;
  width: 100%;
  height: 100%;
  object-fit: cover;
}

.nav-button {
  width: 40px;
  height: 40px;
  border-radius: 50%;
  display: flex;
  justify-content: center;
  align-items: center;
  position: relative;
  z-index: 1;
  outline-offset: 2px;
  border: none;
  cursor: pointer;
  color: white;
  background-color: rgba(255, 255, 255, 0.15);
}

.nav-button:hover {
  background-color: rgba(255, 255, 255, 0.25);
}
</style>